
package {

	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	import flash.utils.*;

	import flash.filesystem.*;

	public class HomunEye extends Sprite {
		// [Embed(systemFont='HiraKakuPro-W3', fontName='Hiragino', mimeType='application/x-font')]
		private var field:Field;

		public function HomunEye () {
			stage.window.visible = true;
			stage.align = StageAlign.TOP;
			// stage.displayState = StageDisplayState.FULL_SCREEN;

			var cellSize:Number = stage.stageHeight / 22 - 1;
			field = new Field(cellSize);
			field.x = stage.stageWidth  / 2 - field.width  / 2
			field.y = stage.stageHeight / 2 - field.height / 2
			addChild(field);

			var prevState:Object = {
				mobs : {}
			};
			var t:Timer = new Timer(1000);
			t.addEventListener(TimerEvent.TIMER, function (e:Event):void {
				var state:Object = parseDumpFile();
				field.center = [state.x, state.y];
				var o:Object;
				for each (o in state.mobs) {
					if (prevState.mobs.hasOwnProperty(o.id)) {
						if (o.x != prevState.mobs[o.id].x ||
						    o.y != prevState.mobs[o.id].y ||
						    state.x != prevState.x ||
						    state.y != prevState.y) {
							field.moveMob(o.id, o.x, o.y);
						}
					} else {
						var tooltip:String;
						tooltip = [
							o.name, "\n",
							"[", o.x, ", ", o.y, "] "
						].join("");
						log("newMob: "+tooltip);
						field.addMob(o.id, o.x, o.y, tooltip, o.isMonster ? 0x990000 : 0x0000ff);
					}
				}
				for each (o in prevState.mobs) {
					if (!state.mobs.hasOwnProperty(o.id)) {
						log("delMob: "+o.name);
						field.mobs[o.id].die();
					}
				}

				prevState = state;
			}, false);
			t.start();
		}

		public function parseDumpFile ():Object {
			var f:File = File.currentDirectory.resolve("dump.txt");
			var ret:Object = new Object();
			if (f.exists) {
				var stream:FileStream = new FileStream();
				stream.open(f, FileMode.READ);
				var data:String = stream.readUTFBytes(stream.bytesAvailable);
				stream.close();
				var lines:Array = data.split(/\n/);
				// x,y,hp,mhp,sp,msp,ohp,omhp,osp,omsp
				var selfs:Array = lines.shift().split(/,/);
				ret = {
					x    : int(selfs[0]),
					y    : int(selfs[1]),
					hp   : int(selfs[2]),
					mhp  : int(selfs[3]),
					sp   : int(selfs[4]),
					msp  : int(selfs[5]),
					ohp  : int(selfs[6]),
					omhp : int(selfs[7]),
					osp  : int(selfs[8]),
					omsp : int(selfs[9])
				};

				ret.mobs = {};
				for (var i:int = 0; i < lines.length; i++) {
					// id,x,y,name,ismonster,humuntype
					var ll:Array = lines[i].split(/,/);
					if (!ll[0]) continue;
					var id:int = int(ll[0]);
					ret.mobs[id] = {
						id        : id,
						x         : int(ll[1]),
						y         : int(ll[2]),
						name      : String(ll[3]),
						isMonster : ll[4] == "false" ? false : true,
						homuntype : int(ll[5])
					};
				}
			}
			return ret;
		}
	}


}
