
require "Class"
require "List"
require "Actor"
require "Homun"
require "RO"

-- reload AI file
function reload ()
	_LOADED = {} -- reset library load
	Config    = nil
	CurrentAI = nil
	Main      = nil
	dofile("AI/USER_AI/AI.lua")
	info"Reloaded"
end

function changeAI (ai, myid)
	try(function ()
		dofile(string.format("AI/USER_AI/%s.lua", ai))
		CurrentAI = _G[ai].new(myid)
	end).catch(function (e)
		error(e)
	end)
end

function Main (myid)
	if not Config then
		Config = INI.new():read("AI/USER_AI/config.ini")
	end
	if not CurrentAI then
		changeAI(Config.AI.current, myid)
	end
	CurrentAI:act()

	-- for shell
	dofile("AI/USER_AI/Shell.lua")
	processShell(CurrentAI)

	local ai = CurrentAI
	local dump = List.new(
		ai.actor:x(),
		ai.actor:y(),
		ai.actor:hp(),
		ai.actor:maxHp(),
		ai.actor:sp(),
		ai.actor:maxSp(),
		ai.owner:hp(),
		ai.owner:maxHp(),
		ai.owner:sp(),
		ai.owner:maxSp(),
		"\n"
	):join(",")

	dump = dump .. Actor.all():map(function (a)
		a:getMonsterInfo()
		local name = a.info.NAME
		if not name then name = a:jobName() end
		return List.new(
			a.id,
			a:x(),
			a:y(),
			name,
			a:isMonster(),
			a:homunType()
		):join(",")
	end):join("\n")


	f = io.open("dump.txt", "w")
	f:write(dump)
	f:close()
end




