
require "Class"
require "List"

SandBox = Class {

	initialize = function (self)
		self.envs = {}
	end,

	load = function (self, file, dir, requirefun)
		local fun = loadfile(file)
		local env = self:copyEnv()
		setfenv(fun, env)
		if dir then
			-- filename わたす関数をラップする
			env.dofile = function (filename, ...)
				dofile(dir.."/"..filename, unpack(arg))
			end
			env.loadfile = function (filename, ...)
				loadfile(dir.."/"..filename, unpack(arg))
			end
			env.io.lines = function (filename, ...)
				io.lines(dir.."/"..filename, unpack(arg))
			end
			env.io.open = function (filename, ...)
				io.open(dir.."/"..filename, unpack(arg))
			end
			env.os.remove = function (filename, ...)
				os.remove(dir.."/"..filename, unpack(arg))
			end
			local f, e = loadstring([[
				require = function (packagename)
					if _LOADED[packagename] then return _LOADED[packagename] end
					local ret
					local found = false
					if not LUA_PATH then local LUA_PATH = "?;?.lua" end
					for v in string.gfind(LUA_PATH, "([^;]+)") do
						filename = string.gsub(v, "%?", packagename)
						_REQUIREDNAME = packagename
						local ok, err = pcall(dofile, filename)
						_REQUIREDNAME = nil
						if ok then 
							if error == nil then
								ret = true
							else
								ret = err
							end
							found = true
							break
						else
							error(err)
						end
					end
					if not found then
						error(string.format("could not load package `%s' from path `%s'",
						      packagename,
						      LUA_PATH))
					end
					_LOADED[packagename] = ret
					return ret
				end
			]])
			d(e)
			setfenv(f, env)
			f()
		end

		-- run file
		fun()

		self.envs[file] = env
		return env
	end,

	pathComponents = function (s)
		local path = List.new()
		for p in string.gfind(s, "(.-)/") do
			path:push(p)
		end
		local _, _, last = string.find(s, ".+/(.+)")
		if last then path:push(last) end
		if path:isEmpty() then path:push(s) end
		return path
	end,

	copyEnv = function (self)
		local ret = {}
		for k, v in pairs(getfenv(0)) do
			if type(v) == "table" then
				ret[k] = {}
				-- 標準ライブラリのため、一段階だけコピー
				for l, w in pairs(v) do
					ret[k][l] = w
				end
			else
				ret[k] = v
			end
		end
		return ret
	end,
}
