#!ruby

require "readline"
require "pathname"

load Pathname.pwd + "shell-const.config"

Readline.completion_proc = Proc.new do |word|
	%w(
	exit
	reload
	test
	ai
	).grep(/\A#{Regexp.quote(word)}/)
end

def command(c, rest)
	cmd = Pathname.new(SHELL_CMD_FILE)
	res = Pathname.new(SHELL_RES_FILE)
	res.truncate(0)
	cmd.open("w") do |f|
		f.puts c
		f.puts rest
	end
	sleep 0.14 while res.zero?
	res.read
end

while l = Readline.readline("> ", true)
	cmd, rest = l.split(/ /, 2)
	if cmd == "exit"
		break
	else
		puts command(cmd, rest)
	end
end
