
require "Actor"
require "Try"
require "Test"


-- dummy position
GetV = function (v, id) 
	if id == 1 then return 10, 20 end
	if id == 2 then return 15, 25 end
	if id == 3 then return -1, -1 end
end

a1 = Actor.new(1)
a2 = Actor.new(2)
a3 = Actor.new(3)

-- set positions
a1:position()
a2:position()

-- basic tests
eq(a1.x, 10)
eq(a2.y, 25)

-- places tests
eq(a1:distanceFrom(a2), 7)
eq(a2:distanceFrom(a1), 7)
eq(a2:isInSight(a1), true)

-- check error
local r
try(function ()
	a3:position()
end).catch(function (e)
	r = e
end)
eq(type(r), "string")

-- ==
eq(a1 == a2, false)
a4 = Actor.new(3)
a5 = Actor.new(3)
eq(a3 == a4, true)
eq(a4 == a4, true)
eq(a4 == a5, true)

-- direction
GetV = function (v, id) 
	if id == 1 then return 10, 10 end -- 基準
	if id == 2 then return 10, 11 end -- 上
	if id == 3 then return 11, 10 end -- 右
	if id == 4 then return 10,  9 end -- 下
	if id == 5 then return  9, 10 end -- 左
end

a1 = Actor.new(1)
a2 = Actor.new(2)
a3 = Actor.new(3)
a4 = Actor.new(4)
a5 = Actor.new(5)

-- 上が北
eq(a1:directionTo(a2), 0)
-- 右が東
eq(a1:directionTo(a3), 90)
-- 下が南
eq(a1:directionTo(a4), 180)
-- 左が西
eq(a1:directionTo(a5), 270)
