
require "INI"
require "Test"

tmpf = os.tmpname()
f = io.open(tmpf, "w")
f:write([[
;hoge
[hoge]
;hoge
foo=bar ;hoge
key=value
;aaa
]])
f:close()

ini = INI.new():read(tmpf)
eq(type(ini.hoge), "table")
eq(ini.hoge.foo, "bar")
eq(ini.hoge.key, "value")

tmpf = os.tmpname()
f = io.open(tmpf, "w")
f:write([[
[hoge]
foo=bar
key=value

[huga]
foo=baz
key=value2
]])
f:close()

ini = INI.new():read(tmpf)
eq(type(ini.hoge), "table")
eq(ini.hoge.foo, "bar")
eq(ini.hoge.key, "value")
eq(ini.huga.foo, "baz")
eq(ini.huga.key, "value2")

ini1 = INI.new({
	foo = {
		a = "aaa",
		b = "bbb",
	},
	bar = {
		a = "aaa",
		b = "bbb",
	},
})
eq(type(ini1.foo), "table")
eq(ini1.foo.a, "aaa")
eq(ini1.bar.a, "aaa")
ini1:write(tmpf)

f = io.open(tmpf, "r")
eq(f:read("*a"), [[
[foo]
a=aaa
b=bbb

[bar]
a=aaa
b=bbb

]])
f:close()


f = io.open(tmpf, "r")
prev = f:read("*a")
f:close()

ini = INI.new():read(tmpf)
ini:write(tmpf)
f = io.open(tmpf, "r")
eq(f:read("*a"), prev)
f:close()
